# By Michael Conry
# michael.conry@softhome.net
# http://www.acronymchile.com/
import Gnuplot
import Numeric
from Numeric import sqrt
from Numeric import sum
from mat_properties import *
from shared import *
import LinearAlgebra
import os


keep_plots=[]
try:
    os.mkdir('figures')
except Exception, b:
    print b

#for theta_deg in Numeric.arange(0,90,2,'f'):
#    theta=Numeric.pi*theta_deg/180.0
#    beta=Numeric.array([[Numeric.cos(theta), Numeric.sin(theta),0.0],
#                        [-Numeric.sin(theta), Numeric.cos(theta),0.0],
#                        [0.0,0.0,1.0]
#                        ])
#    #inas_tensor=make_tensor(inas_30); inas_density=5.67
#    inas_tensor=transform_tensor(make_tensor(inas),beta); inas_density=5.67
#    results,plots=plot_skew_slow_tensor(inas_tensor,inas_density)
#    keep_plots.append(plots[0])

# ##############################################################
theta_deg = 45.0
theta=Numeric.pi*theta_deg/180.0
beta45=Numeric.array([[Numeric.cos(theta), Numeric.sin(theta),0.0],
                    [-Numeric.sin(theta), Numeric.cos(theta),0.0],
                    [0.0,0.0,1.0]
                    ])
# ##############################################################
theta_deg = 30.0
theta=Numeric.pi*theta_deg/180.0
beta30=Numeric.array([[Numeric.cos(theta), Numeric.sin(theta),0.0],
                    [-Numeric.sin(theta), Numeric.cos(theta),0.0],
                    [0.0,0.0,1.0]
                    ])
beta30m=Numeric.array([[Numeric.cos(-theta), Numeric.sin(-theta),0.0],
                    [-Numeric.sin(-theta), Numeric.cos(-theta),0.0],
                    [0.0,0.0,1.0]
                    ])
# ##############################################################
theta_deg = 60.0
theta=Numeric.pi*theta_deg/180.0
beta60=Numeric.array([[Numeric.cos(theta), Numeric.sin(theta),0.0],
                    [-Numeric.sin(theta), Numeric.cos(theta),0.0],
                    [0.0,0.0,1.0]
                    ])
beta60m=Numeric.array([[Numeric.cos(-theta), Numeric.sin(-theta),0.0],
                    [-Numeric.sin(-theta), Numeric.cos(-theta),0.0],
                    [0.0,0.0,1.0]
                    ])
# ##############################################################
theta_deg = 90.0
theta=Numeric.pi*theta_deg/180.0
beta90t=Numeric.array([[Numeric.cos(theta), Numeric.sin(theta),0.0],
                    [-Numeric.sin(theta), Numeric.cos(theta),0.0],
                    [0.0,0.0,1.0]
                    ])
theta_deg = 90.0
theta=Numeric.pi*theta_deg/180.0
beta90tb=Numeric.array([
                    [1.0,                0.0,               0.0 ],
                    [0.0, Numeric.cos(theta), Numeric.sin(theta)],
                    [0.0,-Numeric.sin(theta), Numeric.cos(theta)],
                    ])
beta90tc=Numeric.array([
                    [Numeric.cos(theta), 0.0, Numeric.sin(theta)],
                    [               0.0, 1.0,                0.0],
                    [-Numeric.sin(theta),0.0, Numeric.cos(theta)],
                    ])
# ##############################################################

#inas_tensor=transform_tensor(make_tensor(inas),beta); inas_density=5.67
#inas_tensor=transform_tensor(make_tensor(graph_epox_30),beta); inas_density=gr_ep_d

n = lambda theta: Numeric.array([ Numeric.cos(theta*Numeric.pi/180),0.0,Numeric.sin(theta*Numeric.pi/180.0)],'f')
n2=Numeric.array([0,1,0],'f')



def write_dat(filename,data,angles):
    f=open(filename,'w')
    for i in range(len(data)):
        line=data[i]
        f.write("%f %f %f %f\n"%(angles[i],line[0],line[1],line[2]))

#####################################
if __name__=="__main__":
    inas_tensor=make_tensor(inas)
    inas_density=inas_d
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/inas_0_slow.dat',results[0],angles)
    write_dat('figures/inas_0_skew.dat',results[1],angles)
    #
    inas_tensor=transform_tensor(make_tensor(inas),beta45)
    inas_density=5.67
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/inas_45_slow.dat',results[0],angles)
    write_dat('figures/inas_45_skew.dat',results[1],angles)
    #
    inas_tensor=transform_tensor(make_tensor(inas),beta30)
    inas_density=5.67
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/inas_30_slow.dat',results[0],angles)
    write_dat('figures/inas_30_skew.dat',results[1],angles)
    #
    inas_tensor=make_tensor(aluminium)
    inas_density=2.7
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/alum_slow.dat',results[0],angles)
    write_dat('figures/alum_skew.dat',results[1],angles)
    #
    inas_tensor=make_tensor(graph_epox_0)
    inas_density=1.6
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/graph_epox0_slow.dat',results[0],angles)
    write_dat('figures/graph_epox0_skew.dat',results[1],angles)
    #
    inas_tensor=transform_tensor(make_tensor(graph_epox_0),beta30)
    inas_density=1.6
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/graph_epox30_slow.dat',results[0],angles)
    write_dat('figures/graph_epox30_skew.dat',results[1],angles)
    #
    #inas_tensor= transform_tensor(make_tensor(cdsulfide),beta90)
    inas_tensor= transform_tensor(make_tensor(newgrepox0),beta90tb)
    inas_density=1.6
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/graph_epox90_slow.dat',results[0],angles)
    write_dat('figures/graph_epox90_skew.dat',results[1],angles)
    #
    inas_tensor=make_tensor(quartz)
    inas_density=quartz_density
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/quartz0_slow.dat',results[0],angles)
    write_dat('figures/quartz0_skew.dat',results[1],angles)
    #
    inas_tensor=transform_tensor(make_tensor(quartz),beta90t)
    inas_density=quartz_density
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/quartz90_slow.dat',results[0],angles)
    write_dat('figures/quartz90_skew.dat',results[1],angles)
    #
    inas_tensor=transform_tensor(make_tensor(quartz),beta90tb)
    inas_density=quartz_density
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/quartz90b_slow.dat',results[0],angles)
    write_dat('figures/quartz90b_skew.dat',results[1],angles)
    #
    #inas_tensor=make_tensor(cdsulfide), along axis of symmetry
    inas_tensor=transform_tensor(make_tensor(cdsulfide),beta90tb)
    inas_density=cdsulfide_density
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/cdsulfide0_slow.dat',results[0],angles)
    write_dat('figures/cdsulfide0_skew.dat',results[1],angles)
    #inas_tensor=make_tensor(cdsulfide), normal to axis of symmetry
    inas_tensor=make_tensor(cdsulfide)
    inas_density=cdsulfide_density
    results,plots,angles=plot_skew_slow_tensor(inas_tensor,inas_density)
    write_dat('figures/cdsulfide90_slow.dat',results[0],angles)
    write_dat('figures/cdsulfide90_skew.dat',results[1],angles)
    #
    f=open('figures/inas_0_slow.gp','w')
    f.write("""
    set style line 1 lt 1 lw 5
    set style line 2 lt 2 lw 5
    set style line 3 lt 3 lw 5
    set style line 4 lt 4 lw 1.5 
    plot "figures/inas_0_slow.dat" using 1:2 title "L" ls 1
    replot "figures/inas_0_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/inas_0_slow.dat" using 1:4 title "S2" ls 3
    set polar
    set grid polar
    set style data lines
    set size 1.0,1.4
    set size ratio -1
    set terminal postscript enhanced eps "Times-Roman" 20
    set title "Slowness Curve for InAs {/Symbol f=0\260}"
    set output 'figures/inas_0_slow.eps'
    replot
    ################
    set output '/dev/null'
    plot "figures/inas_45_slow.dat" using 1:2 title "L" ls 1
    replot "figures/inas_45_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/inas_45_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for InAs {/Symbol f=45\260}"
    set yrange [-0.6:0.6]
    set xrange [-0.6:0.6]
    set output 'figures/inas_45_slow.eps'
    replot
    set terminal fig
    set output 'inas_45_slow.fig'
    replot
    set terminal postscript enhanced eps "Times-Roman" 20
    ################
    set output '/dev/null'
    plot "figures/inas_30_slow.dat" using 1:2 title "L" ls 1
    replot "figures/inas_30_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/inas_30_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for InAs {/Symbol f=30\260}"
    set output 'figures/inas_30_slow.eps'
    replot
    ################
    set output '/dev/null'
    plot "figures/alum_slow.dat" using 1:2 title "L" ls 1
    replot "figures/alum_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/alum_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Aluminium"
    set output 'figures/alum_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-0.8:0.8]
    set yrange [-0.8:0.8]
    plot "figures/graph_epox0_slow.dat" using 1:2 title "L" ls 1
    replot "figures/graph_epox0_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/graph_epox0_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Graphite-Epoxy, {/Symbol f=0\260}"
    set output 'figures/graph_epox0_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-0.8:0.8]
    set yrange [-0.8:0.8]
    plot "figures/graph_epox30_slow.dat" using 1:2 title "L" ls 1
    replot "figures/graph_epox30_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/graph_epox30_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Graphite-Epoxy, {/Symbol f=30\260}"
    set output 'figures/graph_epox30_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [*:*]
    set yrange [*:*]
    plot "figures/graph_epox90_slow.dat" using 1:2 title "L" ls 1
    replot "figures/graph_epox90_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/graph_epox90_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Graphite-Epoxy, {/Symbol f=90\260}"
    set output 'figures/graph_epox90_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-0.0004:0.0004]
    set yrange [-0.0004:0.0004]
    plot "figures/quartz0_slow.dat" using 1:2 title "L" ls 1
    replot "figures/quartz0_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/quartz0_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Quartz, {/Symbol f=0\260}"
    set output 'figures/quartz0_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-0.0004:0.0004]
    set yrange [-0.0004:0.0004]
    plot "figures/quartz90_slow.dat" using 1:2 title "L" ls 1
    replot "figures/quartz90_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/quartz90_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Quartz, {/Symbol f=90\260}"
    set output 'figures/quartz90_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-0.0004:0.0004]
    set yrange [-0.0004:0.0004]
    plot "figures/quartz90b_slow.dat" using 1:2 title "L" ls 1
    replot "figures/quartz90b_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/quartz90b_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Quartz, {/Symbol f=90\260}"
    set output 'figures/quartz90b_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [*:*]
    set yrange [*:*]
    plot "figures/cdsulfide0_slow.dat" using 1:2 title "L" ls 1
    replot "figures/cdsulfide0_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/cdsulfide0_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Cadmium Sulfide, {/Symbol f=0\260}"
    set output 'figures/cdsulfide0_slow.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [*:*]
    set yrange [*:*]
    plot "figures/cdsulfide90_slow.dat" using 1:2 title "L" ls 1
    replot "figures/cdsulfide90_slow.dat" using 1:3 title "S1" ls 2
    replot "figures/cdsulfide90_slow.dat" using 1:4 title "S2" ls 3
    set title "Slowness Curve for Cadmium Sulfide, {/Symbol f=90\260}"
    set output 'figures/cdsulfide90_slow.eps'
    replot
    """)
    f=open('figures/inas_0_skew.gp','w')
    f.write("""
    set style line 1 lt 1 lw 5
    set style line 2 lt 2 lw 5
    set style line 3 lt 3 lw 5
    set style line 4 lt 4 lw 1.5 
    plot "figures/inas_0_skew.dat" using 1:2 title "L" ls 1
    replot "figures/inas_0_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/inas_0_skew.dat" using 1:4 title "S2" ls 3
    set polar
    set grid polar
    set style data lines
    set size 1.0,1.4
    set size ratio -1
    set terminal postscript enhanced eps "Times-Roman" 20
    set title "Skew Curve for InAs {/Symbol f=0\260}"
    set output 'figures/inas_0_skew.eps'
    replot
    ################
    set output '/dev/null'
    plot "figures/inas_45_skew.dat" using 1:2 title "L" ls 1
    replot "figures/inas_45_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/inas_45_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for InAs {/Symbol f=45\260}"
    set yrange [-10.0:10.0]
    set xrange [-10.0:10.0]
    set output 'figures/inas_45_skew.eps'
    replot
    ################
    set output '/dev/null'
    plot "figures/inas_30_skew.dat" using 1:2 title "L" ls 1
    replot "figures/inas_30_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/inas_30_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for InAs {/Symbol f=30\260}"
    set output 'figures/inas_30_skew.eps'
    replot
    ################
    set output '/dev/null'
    plot "figures/alum_skew.dat" using 1:2 title "L" ls 1
    replot "figures/alum_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/alum_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Aluminium"
    set output 'figures/alum_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-50:50]
    set yrange [-50:50]
    plot "figures/graph_epox0_skew.dat" using 1:2 title "L" ls 1
    replot "figures/graph_epox0_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/graph_epox0_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Graphite-Epoxy, {/Symbol f=0\260}"
    set output 'figures/graph_epox0_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-50:50]
    set yrange [-50:50]
    plot "figures/graph_epox30_skew.dat" using 1:2 title "L" ls 1
    replot "figures/graph_epox30_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/graph_epox30_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Graphite-Epoxy, {/Symbol f=30\260}"
    set output 'figures/graph_epox30_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange restore
    set yrange restore
    plot "figures/graph_epox90_skew.dat" using 1:2 title "L" ls 1
    replot "figures/graph_epox90_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/graph_epox90_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Graphite-Epoxy, {/Symbol f=90\260}"
    set output 'figures/graph_epox90_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-25:25]
    set yrange [-25:25]
    plot "figures/quartz0_skew.dat" using 1:2 title "L" ls 1
    replot "figures/quartz0_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/quartz0_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Quartz, {/Symbol f=0\260}"
    set output 'figures/quartz0_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-30:30]
    set yrange [-30:30]
    plot "figures/quartz90_skew.dat" using 1:2 title "L" ls 1
    replot "figures/quartz90_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/quartz90_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Quartz, {/Symbol f=90\260}"
    set output 'figures/quartz90_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-30:30]
    set yrange [-30:30]
    plot "figures/quartz90b_skew.dat" using 1:2 title "L" ls 1
    replot "figures/quartz90b_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/quartz90b_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Quartz, {/Symbol f=90\260}"
    set output 'figures/quartz90b_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [*:*]
    set yrange [*:*]
    plot "figures/cdsulfide0_skew.dat" using 1:2 title "L" ls 1
    replot "figures/cdsulfide0_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/cdsulfide0_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Cadmium Sulfide, {/Symbol f=0\260}"
    set output 'figures/cdsulfide0_skew.eps'
    replot
    ################
    set output '/dev/null'
    set xrange [-2.5:2.5]
    set yrange [-2.5:2.5]
    plot "figures/cdsulfide90_skew.dat" using 1:2 title "L" ls 1
    replot "figures/cdsulfide90_skew.dat" using 1:3 title "S1" ls 2
    replot "figures/cdsulfide90_skew.dat" using 1:4 title "S2" ls 3
    set title "Skew Curve for Cadmium Sulfide, {/Symbol f=90\260}"
    set output 'figures/cdsulfide90_skew.eps'
    replot
    """)
