# By Michael Conry
# michael.conry@softhome.net
# http://www.acronymchile.com/
import Numeric, LinearAlgebra
import Gnuplot
from Numeric import sum
from copy import copy
from Numeric import sqrt
from Numeric import sum
coeffs = ["0,0","1,1","2,2","1,2","0,2","0,1"]

def make_micktrial(tensor,alph,c2):
    """REALLY EXPERIMENTAL AT the moment
tensor should be the stiffness tensor c_{ijkl}, alph is ratio of
wavenumber in x_3 dirxn relative to that in x_1 dirxn.
c is a squared phase velocity in the x_1 dirxn which has been multiplied
by density.  Aim here will be to find alphas satisfying a particular value
of c2.
"""
    n=Numeric.array([1,0,alph])/sqrt(1+alph**2)
    #n=Numeric.array([1,0,alph])
    print n
    NA=Numeric.NewAxis
    #tensor3=(sum( sum(tensor*n[NA,:,NA,NA],1) * n[NA,:,NA],1) - Numeric.identity(3,Numeric.Float)*c2 )
    tensor3=(sum( sum(tensor*n[NA,:,NA,NA],1) * n[NA,:,NA],1))
    #return(LinearAlgebra.determinant(tensor3))
    return(tensor3)

def givequadcoeffs(reduced,c2):
    "Eqn (5.30), applies to sagittal plane motion"
    c=reduced
    ## A=c[2,2]*c[4,4]
    A=1.0
    # From plots, the next two lines appear to be equivalent.  Former is
    # from book.  Don't know where i got second one (maybe just rearranged
    # stuff).  Actually, think i plugged through derivation, and it popped
    # out that way.  Also, note that there is a correction here compared to
    # the expression in the book (second set of brackets in B is minus in
    # book but plus here).
    ## B=(c[0,0]-c2)*c[2,2]+(c[4,4]-c2)*c[4,4]-(c[0,2]+c[4,4])**2
    B=( (c[0,0]/c[4,4]-c2/c[4,4]) 
            + (c[4,4]/c[2,2]-c2/c[2,2])
            - (c[0,2]/Numeric.sqrt(c[2,2]*c[4,4])
                    + c[4,4]/Numeric.sqrt(c[2,2]*c[4,4]))**2 )
    #B=(c[0,0]-c2)*c[2,2]+(c[4,4]-c2)*c[4,4]-(c[0,2]+c[4,4])**2
    #B=-(c[0,2]+c[4,4])**2 + c[0,0]*c[2,2] + c[4,4]**2 - c2*(c[2,2]+c[4,4])
    C=(c[0,0]/c[2,2]-c2/c[2,2])*(1-c2/c[4,4])
    return(A,B,C)

def givecoeffs(reduced,c2):
    # Thu Jan  9 03:36:01 GMT 2003: I suspect there might be an error in
    # this, and it's possibly from the book (though an error in the code is
    # highly probable too).
    #
    ####### Next is eqns (5.11), (5.12) pg 74 of Nayfeh's book.
    # Include 1 at the beginning to make easier to use MLab.roots() fn.
    c=reduced # This will save some typing!
    delta=c[2,2]*c[3,3]*c[4,4]-c[2,2]*c[3,4]**2
    #######
    A1=( c[0,0]*c[2,2]*c[3,3]
    -c[0,2]**2*c[3,3]
    +2*c[0,2]*c[2,5]*c[3,4]
    -2*c[0,2]*c[3,3]*c[4,4]
    +2*c[0,2]*c[3,4]**2
    -2*c[0,5]*c[2,2]*c[3,4]
    +c[2,2]*c[4,4]*c[5,5]
    -c[2,5]**2*c[4,4]
    -(c[2,2]*c[3,3] + c[2,2]*c[4,4] + c[3,3]*c[4,4] - c[3,4]**2)*c2)/delta
    #######
    A2=(
    c[0,0]*c[2,2]*c[5,5]
    -c[0,0]*c[2,5]**2
    -2*c[0,0]*c[2,5]*c[3,4]
    +c[0,0]*c[3,3]*c[4,4]
    -c[0,0]*c[3,4]**2
    +c[0,2]**2*c[5,5]
    +2*c[0,2]*c[0,5]*c[2,5]
    +2*c[0,2]*c[0,5]*c[3,4]
    -2*c[0,2]*c[4,4]*c[5,5] - c[0,5]**2*c[2,2] + 2*c[0,5]*25*c[4,4]
    -(c[0,0]*c[2,2] + c[0,0]*c[3,3] - c[0,2]**2 - 2*c[0,2]*c[4,4] - 2*c[0,5]*c[3,4]
    + c[2,2]*c[5,5] - c[2,5]**2 - 2*c[2,5]*c[3,4] + c[3,3]*c[4,4] - c[3,4]**2 + c[4,4]*c[5,5])*c2
    +(c[2,2] + c[3,3] + c[4,4])*c2**2)/delta
    #######
    A3=(
    c[0,0]*c[4,4]*c[5,5] - c[0,5]**2*c[4,4]
    -(c[0,0]*c[4,4] + c[0,0]*c[5,5] + c[0,5]**2 +c[4,4]*c[5,5])*c2
    +(c[0,0] + c[4,4] + c[5,5])*c2**2 -c2**3)/delta
    #######
    return(1,A1,A2,A3)
    

def micktrial2(alph2,A1,A2,A3):
    """this is a bit like make_micktrial.  c2 is $\rho c^2$.
alph is same as before.  Use reduced form of material properties here
(though i suppose i could throw a quick conversion in first if i liked).
This appears to give the same residual behaviour (same roots at least) as
the determinant above"""
    # Note, I'm going to change it so that this now takes in alph2, which
    # is $\alpha^2$.  Thus, it is a cubic, and the alph2 terms should
    # always be real (AFAICS!). With this, we still get the same behaviour.
    return(alph2**3 + A1*alph2**2 + A2*alph2**1 +A3)



def make_lambda_tensor(tensor,n):
    """Returns lambda matrix (still needs division by density)
for a  stiffness TENSOR input (array 3x3x3x3), followed by a
propagation direction.
Equation is:
$ \Lambda_{il} = \lambda_{ijkl} n_j n_k $"""
    #~~~~~~~~~~|_____________________________________________
    #  REDONE!                                               |
    #________________________________________________________|
    # This is a quicker way to do the same thing, almost easier
    # to read too, more apparent what axis the
    # projection/multiplication is being done.  Two steps are
    # just nested. Summation is over axis "1", which is also 
    # the location of the ":" in the expanded n, as you would
    # expect.
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    NA=Numeric.NewAxis
    tensor3=sum( sum(tensor*n[NA,:,NA,NA],1) * n[NA,:,NA],1)
    # Sweet!
    return(tensor3)

#########################################################

def transform_reduced(c,angle):
    """c is reduced stiffness matrix, angle is rotation angle
in degrees"""
    # Only good for monoclinic or greater symmetry!!!!
    theta=Numeric.pi*angle/180.0
    S=Numeric.sin(theta); G=Numeric.cos(theta)
    c2=Numeric.zeros((6,6),Numeric.Float)
    c2[0,0]=(
    c[0,0]*G**4 +c[1,1]*S**4+2*(c[0,1]+2*c[5,5])* S**2 *G**2
        +4*(c[0,5]*G**2 + c[1,5]*S**2)*S*G
            )
    c2[0,1]=c2[1,0]=(
        (c[0,0]+c[1,1]-2*c[0,1]-4*c[5,5])* S**2 * G**2 +c[0,1]
        +2*(c[0,5]-c[1,5])*(S**2 - G**2)*S*G
            )
    c2[0,2]=c2[2,0]=(
            c[0,2]*G**2+c[1,2]*S**2+2*c[2,5]*S*G
            )
    c2[0,5]=c2[5,0]=(
            (c[0,1] - c[0,0] + 2*c[5,5]) * S * G**3
            + (c[1,1] - c[0,1] - 2*c[5,5]) * G * S**3
            + 3 * (c[1,5] - c[0,5]) * S**2 * G**2
            + c[0,5] * G**4 - c[1,5] * S**4
            )
    c2[1,1]=(
    c[0,0]*S**4+c[1,1]*G**4+2*(c[0,1]+2*c[5,5])* S**2 * G**2
    -4*(c[0,5] * S**2 +c[1,5] * G**2)*S*G
            )
    c2[1,2]=c2[2,1]=(
            c[1,2]*G**2  +  c[0,2]*S**2  -  2*c[2,5]*S*G
            )
    c2[1,5]=c2[5,1]=(
            (c[0,1]+2*c[5,5]-c[0,0])*G*S**3
            +(c[1,1]-c[0,1]-2*c[5,5])*S*G**3
            +3*(c[0,5]-c[1,5])*S**2*G**2
            -c[0,5]*S**4 +c[1,5]*G**4
            )
    c2[2,2]=c[2,2]
    c2[2,5]=c2[5,2]=(
            (c[1,2]-c[0,2])*S*G + c[2,5]*(G**2-S**2)
            )
    c2[3,3]=(
            c[3,3]*G**2 + c[4,4]*S**2 -2*c[3,4]*S*G
            )
    c2[3,4]=c2[4,3]=(
            (c[3,3]-c[4,4])*S*G+c[3,4]*(G**2-S**2)
            )
    c2[4,4]=(
            c[4,4]*G**2+c[3,3]*S**2+2*c[3,4]*S*G
            )
    c2[5,5]=(
        c[5,5]+(c[0,0]+c[1,1]-2*c[0,1]-4*c[5,5])*S**2*G**2+
            2*(c[0,5]-c[1,5])*(S**2-G**2)*S*G
            )
    return(c2)

def make_lambda(c,n):
    """Returns \Lambda matrix (still needs division by density)
for a REDUCED STIFFNESS MATRIX input (Array 6x6) along with a
propagation direction vector.  """
    # Have done the sums out by hand rather than looking at
    # underlying sense.  These expressions are lifted straight
    # from Nayfeh's book.  Note that, as in the book, \Lambda
    # is explicitly symmetric.  This is immediately plausible
    # anyway given that c (stiffness matrix) is always
    # symmetric.
    #
    Lambda=Numeric.zeros((3,3),Numeric.Float)
    Lambda[0,0]=(
                c[0,0]*n[0]**2 +
                c[5,5]*n[1]**2 +
                c[4,4]*n[2]**2 +
              2*c[0,5]*n[0]*n[1] +
              2*c[0,4]*n[0]*n[2] +
              2*c[4,5]*n[1]*n[2])
    Lambda[0,1]=Lambda[1,0]=(
                c[0,5]*n[0]**2 +
                c[1,5]*n[1]**2 +
                c[3,4]*n[2]**2 +
               (c[0,1]+c[5,5])*n[0]*n[1] +
               (c[0,3]+c[4,5])*n[0]*n[2] +
               (c[3,5]+c[1,4])*n[1]*n[2])
    Lambda[0,2]=Lambda[2,0]=(
                c[0,4]*n[0]**2 +
                c[3,5]*n[1]**2 +
                c[2,4]*n[2]**2 +
               (c[0,3]+c[4,5])*n[0]*n[1] +
               (c[0,2]+c[4,4])*n[0]*n[2] +
               (c[2,5]+c[3,4])*n[1]*n[2])
    Lambda[1,1]=(
                c[5,5]*n[0]**2 +
                c[1,1]*n[1]**2 +
                c[3,3]*n[2]**2 +
              2*c[1,5]*n[0]*n[1] +
              2*c[3,5]*n[0]*n[2] +
              2*c[1,3]*n[1]*n[2])
    Lambda[1,2]=Lambda[2,1]=(
                c[4,5]*n[0]**2 +
                c[1,3]*n[1]**2 +
                c[2,3]*n[2]**2 +
               (c[3,5]+c[1,4])*n[0]*n[1] +
               (c[2,5]+c[3,4])*n[0]*n[2] +
               (c[1,2]+c[3,3])*n[1]*n[2])
    Lambda[2,2]=(
                c[4,4]*n[0]**2 +
                c[3,3]*n[1]**2 +
                c[2,2]*n[2]**2 +
              2*c[3,4]*n[0]*n[1] +
              2*c[2,4]*n[0]*n[2] +
              2*c[2,3]*n[1]*n[2])
    return(Lambda)

######################################################

# Next two transform from tensor to reduced notation and back
# again...
def make_tensor(c):
    """Go from reduced stiffness matrix to full 3x3x3x3 tensor.
Input should be a 6x6 Numeric array with stiffness constants.
It is expected that input is symmetric."""
    # Note that ideally this would only scan upper/lower
    # triangular part of input matrix (other part should be
    # same).  As this code stands, it specifies elements of the
    # tensor more than once (i.e. same thing happens when x=1,
    # y=2 as when x=2 and y=1).  This is inelegant, but the
    # code is straightforward and seems to work.
    tensor=Numeric.zeros((3,3,3,3),Numeric.Float)
    for x in range(Numeric.shape(c)[0]):
        for y in range(Numeric.shape(c)[1]):
            # The coeffs array maps from reduced to expanded
            # notation (i.e.  1,1 goes to 1; 2,3 goes to 4 (as
            # written).  Note that python indexes from 0, so
            # all indices are "minus one".
            a=eval("["+coeffs[x]+"]")
            b=eval("["+coeffs[y]+"]")
            for idx in equivalent_indexes(a[0],a[1],b[0],b[1]):
                # Handle the allowed permutations, e.g. if we
                # have just found 1213, then we can also set
                # 2113 1231 2131 1312 3112 1321 3121
                tensor[idx]=c[x,y]
    return(tensor)

def make_reduced(tensor):
    """Go to reduced stiffness matrix from full 3x3x3x3 tensor.
Input should be a 3x3x3x3 Numeric array with stiffness
constants.  The tensor is expected to be a well-formed 
stiffness tensor."""
    # See notes on make_tensor().  Gist is that for each
    # element of c, find the element of tensor it corresponds
    # to (via coeffs array) and take value from there (there
    # should be up to 7 other values in tensor identical (see
    # equivalent_indices).
    #
    c = Numeric.zeros((6,6),Numeric.Float)
    for x in range(Numeric.shape(c)[0]):
        for y in range(Numeric.shape(c)[1]):
            a = eval("["+coeffs[x]+"]")
            b = eval("["+coeffs[y]+"]")
            c[x,y] = tensor[a[0],a[1],b[0],b[1]]
            # Next line surely superflous but don't feel like
            # taking it out!
            c[y,x] = tensor[a[0],a[1],b[0],b[1]]
    return(c)

######################################################

def cross_product(a,b):
    """I am sure there is a function in the
Numeric/LinearAlgebra/MLab packages to do this, but I cannot
see it so I wrote my own.  Just applies determinant method,
in an obvious way.  Input is two arrays/lists of length 3."""
    n=Numeric.zeros(3,a.typecode())
    n[0]=a[1]*b[2]-a[2]*b[1]
    n[1]=a[2]*b[0]-a[0]*b[2]
    n[2]=a[0]*b[1]-a[1]*b[0]
    return n

######################################################

def equivalent_indexes(i,j,k,l):
    """Returns a list of equivalent indices, including the
original set.  Sensible arguments are four integers.  Output is
a list of sequences.  These equivalences are based on symmetry
and energy considerations."""
    result=[]
    # I will just do this longhand, as it is simplest that way
    # and probably fastest too: First swap within pairs (four
    # possibilities) (include initial indices. Wasteful,
    # perhaps, but explicit).
    result.append((i,j,k,l))
    result.append((j,i,k,l))
    result.append((i,j,l,k))
    result.append((j,i,l,k))
    # Then swap the pairs, and repeat in-pair swapping ((four
    # more possibilities))
    result.append((k,l,i,j))
    result.append((l,k,i,j))
    result.append((k,l,j,i))
    result.append((l,k,j,i))
    return(result)

######################################################

def transform_tensor(c,b):
    """Input is a tensor c (array, 3x3x3x3) and a
transformation matrix,  b (array, 3x3).  The expression being
evaluated here is:
c_{mnop}=c_{ijkl} b_{mi} b_{nj} b_{ok} b_{pl}
It would be nice to generalise for transformation of any
tensor, but I don't have need at moment.  Also algorithm would
have to be pretty smart."""
    # There are rather a lot of "for" loops in this code, but
    # it DOES appear to work, and is at least quite 
    # transparent.  There is almost certainly a shortcut which
    # could be used here.  This way is very explicit.
    #
    temp=Numeric.zeros((3,3,3,3),Numeric.Float)
    result=Numeric.zeros((3,3,3,3),Numeric.Float)
    # Loop over the indices of the output
    for m in range(3):
        for n in range(3):
            for o in range(3):
                for p in range(3):
                    # Reset total.
                    total=0
                    # Now, build an element of the output...
                    # lots of multiplications, and keep adding
                    # to running total.
                    for i in range(3):
                        for j in range(3):
                            for k in range(3):
                                for l in range(3):
                                    total+=(
                      c[i,j,k,l]*b[m,i]*b[n,j]*b[o,k]*b[p,l]
                                           )
                    result[m,n,o,p]=total
    return(result)
######################################################

def sort_modesb(evals,evecs,n,n2,theta):
    """This is another approach.  Identify the first (quasi-longitudinal)
mode as before.  Then, find second mode by taking dot products with the
second vector from the last set.  This vector is supplied as an argument.
Most comments have been stripped from this function.  The first time this
is called, n2 will be [0,1,0]."""
    outvals=[]; outvecs=[]; 
    used=Numeric.ones(3)
    #
    long_cond=[abs(sum(n*evecs[0])),abs(sum(n*evecs[1])),abs(sum(n*evecs[2]))]
    #
    position=long_cond.index(max(long_cond))
    #print "%f %f"%(theta*180/Numeric.pi,sum(n*evecs[position]))
    used[position]=0
    outvals.append(evals[ position ])
    outvecs.append(evecs[ position ])
    #
    n2_cond=[abs(sum(n2*evecs[0])),abs(sum(n2*evecs[1])),abs(sum(n2*evecs[2]))]
    position=n2_cond.index(max(n2_cond))
    #print position
    used[position]=0
    outvals.append(evals[ position ])
    outvecs.append(evecs[ position ])

    # Used should have zeroes in the indices of the bits we have picked
    # already.  Use this to find the remaining entry.
    outvecs.append(Numeric.sum(Numeric.transpose(evecs)*used,-1))
    outvals.append(Numeric.sum(evals*used))
    outvecs=Numeric.array(outvecs)
    outvals=Numeric.array(outvals)
    return(outvals,outvecs)

def plot_skew_slow_tensor(tensor, density):
    """Take stiffness-tensor, density, and plot slowness and skew \
surfaces"""
    from Numeric import arcsin,arccos
    inc=2*Numeric.pi/2000.0; angles=Numeric.arange(0.0,2*Numeric.pi+inc,inc)

    slowness=[]; skew=[]

    for theta in angles:
        n=Numeric.array([Numeric.cos(theta),0.0,Numeric.sin(theta)])
        vecs=LinearAlgebra.eigenvectors(
                            make_lambda_tensor(tensor,n)/density)[1]
        vals=LinearAlgebra.eigenvectors(
                            make_lambda_tensor(tensor,n)/density)[0]
        if not slowness:
            print "first set"
            vals,vecs=sort_modesb(vals.tolist(),vecs,n,Numeric.array([0,1,0]),theta)
        else:
            vals,vecs=sort_modesb(vals.tolist(),vecs,lastvecs[0],lastvecs[1],theta)
            #vals,vecs=sort_modesb(vals.tolist(),vecs,n,Numeric.array([0,1,0]))
        # Next is a bounds check, to ensure that the modulus of vectors is
        # nogreater than unity.
        for i in range(3):
            if sum(vecs[i]**2) >= 1.0:
                vecs[i] = vecs[i] / (sqrt( sum( vecs[i]**2 ) ) *1.0000001)
        slowness.append(vals)
        lastvecs=vecs
        try:
            # Rationale is that vecs[0] (which should be longitudinal)
            # should lie parallel with n (propagation direction). vecs[1]
            # and vecs[2] should be at right angles (two shear modes). The
            # following gives indications of how far from these ideals we
            # are.
            # skew.append(
            # [arccos( abs( sum(n*vecs[0]) ) )*180/Numeric.pi,
            #  arcsin( abs( sum(n*vecs[1]) ) )*180/Numeric.pi,
            #  arcsin( abs( sum(n*vecs[2]) ) )*180/Numeric.pi]
            #            )
            n2=Numeric.array([0,1,0],'f')
            #print vecs[0]
            #skew.append(
            #[( ( sum(n*vecs[0]) ) ),
            # ( ( sum(n2*vecs[1]) ) ),
            # ( ( sum(n2*vecs[2]) ) )]
            #           )
            skew.append(
            [arccos( abs( sum(n*vecs[0]) ) )*180/Numeric.pi,
             arcsin( abs( sum(n*vecs[1]) ) )*180/Numeric.pi,
             arcsin( abs( sum(n*vecs[2]) ) )*180/Numeric.pi]
                       )
        except Exception, b:
            print b
            print "hit an exception"
            print(sum(vecs[0]**2), n, sum(n*vecs[0]))
            print(sum(vecs[1]**2), n, sum(n*vecs[1]))
            print(sum(vecs[2]**2), n, sum(n*vecs[2]))
            return( vecs[0] , n , sum(n*vecs[2]) )
    try:    
        results=[1.0/Numeric.sqrt(Numeric.array(slowness)),Numeric.array(skew)]
    except:
        fff=open('m.txt','w')
        for x in slowness:
            print x
            fff.write('%f %f %f\n'%tuple(x) )
        fff.close()
        return(Numeric.array(slowness))
    #
    plots=[Gnuplot.Gnuplot(), Gnuplot.Gnuplot()]
    for pl in plots:
        pl('set style data lines'); pl('set polar'); pl('set grid polar')
        pl('set size square')
        pl('set style data lines'); 
        for i in range(Numeric.shape(results[plots.index(pl)])[1]):
            pl.replot(Gnuplot.Data(angles,results[plots.index(pl)][:,i],
                                        title="%d"%i))
    return(results,plots,angles)

def plot_skew_slow(c, density):
    """This needs fixing, to make it like the tensor version \
Take reduced stiffness-matrix, density, and plot slowness and skew \
surfaces"""
    from Numeric import arcsin,arccos
    # inc is angle increment, angles are a range of angles around 360degrees
    inc=2*Numeric.pi/200.0; angles=Numeric.arange(0.0,2*Numeric.pi+inc,inc)
    eigenvalues=[]; skew=[]
    for theta in angles:
        # form the propagation direction vector, n
        n=Numeric.array([Numeric.cos(theta),0.0,Numeric.sin(theta)])
        # LinearAlgebra.eigenvectors() returns eigenvalues and eigenvectors
        # in a list:
        vecs=LinearAlgebra.eigenvectors(
                            make_lambda(c,n)/density)[1]
        vals=LinearAlgebra.eigenvectors(
                            make_lambda(c,n)/density)[0]
        # Try to sort eigenvalues/vectors according to mode
        vals,vecs=sort_modes(vals.tolist(),vecs,n)
        # Next is a bounds check, to ensure that the modulus of vectors is
        # nogreater than unity. Avoids later probs with arccos,arcsin.
        for i in range(3):
            if sum(vecs[i]**2) > 1.0:
                vecs[i] = vecs[i] / (sqrt( sum( vecs[i]**2 ) ) *1.0000001)
        eigenvalues.append(vals)
        try:
            skew.append(
            [arccos( abs( sum(n*vecs[0]) ) )*180/Numeric.pi,
             arcsin( abs( sum(n*vecs[1]) ) )*180/Numeric.pi,
             arcsin( abs( sum(n*vecs[2]) ) )*180/Numeric.pi]
                       )
        except:
            print "Usually means we have done arccos(1.01) or similar"
            return( vecs[0] , n , sum(n*vecs[2]) ) # for debug purposes.
    # Eigenvalues are squares of velocity.  We want slowness.  Also, put
    # results (slownesses, skew-angles) in a list.
    results=[1.0/Numeric.sqrt(Numeric.array(eigenvalues)),Numeric.array(skew)]
    #
    plots=[Gnuplot.Gnuplot(), Gnuplot.Gnuplot()]
    for pl in plots:
        pl('set style data lines'); pl('set polar'); pl('set grid polar')
        pl('set size square')
        for i in range(Numeric.shape(results[plots.index(pl)])[1]):
            pl.replot(Gnuplot.Data(angles,results[plots.index(pl)][:,i],
                                        title="%d"%i))
    return(results,plots,angles)

